<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfileItem_V1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfProfileItem_V1 extends AbstractStructArrayBase
{
    /**
     * The ProfileItem_V1
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfileItem_V1[]
     */
    public $ProfileItem_V1;
    /**
     * Constructor method for ArrayOfProfileItem_V1
     * @uses ArrayOfProfileItem_V1::setProfileItem_V1()
     * @param \StructType\ProfileItem_V1[] $profileItem_V1
     */
    public function __construct(array $profileItem_V1 = array())
    {
        $this
            ->setProfileItem_V1($profileItem_V1);
    }
    /**
     * Get ProfileItem_V1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfileItem_V1[]|null
     */
    public function getProfileItem_V1()
    {
        return isset($this->ProfileItem_V1) ? $this->ProfileItem_V1 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProfileItem_V1 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProfileItem_V1 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProfileItem_V1ForArrayConstraintsFromSetProfileItem_V1(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProfileItem_V1ProfileItem_V1Item) {
            // validation for constraint: itemType
            if (!$arrayOfProfileItem_V1ProfileItem_V1Item instanceof \StructType\ProfileItem_V1) {
                $invalidValues[] = is_object($arrayOfProfileItem_V1ProfileItem_V1Item) ? get_class($arrayOfProfileItem_V1ProfileItem_V1Item) : sprintf('%s(%s)', gettype($arrayOfProfileItem_V1ProfileItem_V1Item), var_export($arrayOfProfileItem_V1ProfileItem_V1Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProfileItem_V1 property can only contain items of type \StructType\ProfileItem_V1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProfileItem_V1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileItem_V1[] $profileItem_V1
     * @return \ArrayType\ArrayOfProfileItem_V1
     */
    public function setProfileItem_V1(array $profileItem_V1 = array())
    {
        // validation for constraint: array
        if ('' !== ($profileItem_V1ArrayErrorMessage = self::validateProfileItem_V1ForArrayConstraintsFromSetProfileItem_V1($profileItem_V1))) {
            throw new \InvalidArgumentException($profileItem_V1ArrayErrorMessage, __LINE__);
        }
        if (is_null($profileItem_V1) || (is_array($profileItem_V1) && empty($profileItem_V1))) {
            unset($this->ProfileItem_V1);
        } else {
            $this->ProfileItem_V1 = $profileItem_V1;
        }
        return $this;
    }
    /**
     * Add item to ProfileItem_V1 value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileItem_V1 $item
     * @return \ArrayType\ArrayOfProfileItem_V1
     */
    public function addToProfileItem_V1(\StructType\ProfileItem_V1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileItem_V1) {
            throw new \InvalidArgumentException(sprintf('The ProfileItem_V1 property can only contain items of type \StructType\ProfileItem_V1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProfileItem_V1[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfileItem_V1|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfileItem_V1|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfileItem_V1|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfileItem_V1|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfileItem_V1|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileItem_V1
     */
    public function getAttributeName()
    {
        return 'ProfileItem_V1';
    }
}
